Qore Programming Language: QoreBigIntNode Class Reference

Qore Programming Language 0.8.11

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
QoreBigIntNode Class Reference

this class implements Qore's 64-bit integer data type, reference-counted, dynamically-allocated only More...

`#include <QoreBigIntNode.h>`

Inheritance diagram for QoreBigIntNode:
[legend]
Collaboration diagram for QoreBigIntNode:
[legend]

## Public Member Functions
DLLEXPORT | QoreBigIntNode ()
| creates a new integer with the value 0
DLLEXPORT | QoreBigIntNode (int64 v)
| creates a new integer with the value of "v" More...
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, ExceptionSink *xsink) const
| concatenates the value of the integer to an existing QoreString More...
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, ExceptionSink *xsink) const
| returns a QoreString representing the integer More...
virtual DLLEXPORT DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this integer (interpreted as an offset in seconds from January 1, 1970) More...
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of this integer (interpreted as an offset in seconds from January 1, 1970) to the DateTime reference passed More...
virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns a string representing the integer and sets del to true More...
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the string representation of the integer to an existing QoreString reference More...
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality without the possibility of type conversion (hard compare) More...
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality with the possibility of type conversion (soft compare) More...
virtual DLLEXPORT AbstractQoreNode * | parseInit (LocalVar *oflag, int pflag, int &lvids, const QoreTypeInfo *&typeInfo)
| returns the type information
virtual DLLEXPORT AbstractQoreNode * | realCopy () const
| returns a copy of the object; the caller owns the reference count More...
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type More...
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
DLLEXPORT int64 | bigIntEval (ExceptionSink *xsink) const
| evaluates the object and returns a 64-bit integer value More...
DLLEXPORT bool | boolEval (ExceptionSink *xsink) const
| evaluates the object and returns a boolean value More...
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing More...
DLLEXPORT AbstractQoreNode * | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0) More...
DLLEXPORT AbstractQoreNode * | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument More...
DLLEXPORT double | floatEval (ExceptionSink *xsink) const
| evaluates the object and returns a floating-point value More...
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object More...
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object More...
DLLEXPORT double | getAsFloat () const
| returns the float value of the object More...
DLLEXPORT int | getAsInt () const
| returns the integer value of the object More...
DLLLOCAL qore_type_t | getType () const
| returns the data type More...
DLLEXPORT int | integerEval (ExceptionSink *xsink) const
| evaluates the object and returns an integer value More...
DLLLOCAL bool | is_value () const
| returns true if the node represents a value More...
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not More...
DLLEXPORT void | ref () const
| increments the reference count
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count More...
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLLOCAL bool | is_unique () const
| returns true if the reference count is 1 More...
DLLLOCAL int | reference_count () const
| gets the reference count More...
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count More...
DLLEXPORT void | ROreference () const
| atomically increments the reference count

## Static Public Member Functions
static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)
static DLLLOCAL const char * | getStaticTypeName ()
| returns the type code (useful in templates)
static DLLLOCAL int64 | getValue (AbstractQoreNode *v)
| returns the integer value (useful in templates)

## Public Attributes
int64 | val
| value of the integer

## Additional Inherited Members
Protected Member Functions inherited from SimpleValueQoreNode
virtual DLLEXPORT int64 | bigIntEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT bool | boolEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT AbstractQoreNode * | evalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT AbstractQoreNode * | evalImpl (bool &needs_deref, ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT double | floatEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
virtual DLLEXPORT int | integerEvalImpl (ExceptionSink *xsink) const
| should never be called for value types More...
Protected Member Functions inherited from AbstractQoreNode
virtual DLLEXPORT | ~AbstractQoreNode ()
| default destructor does nothing More...
Protected Attributes inherited from AbstractQoreNode
bool | custom_reference_handlers: 1
| set to one for objects that need custom reference handlers
bool | needs_eval_flag: 1
| if this is true then the type can be evaluated
bool | there_can_be_only_one: 1
| if this is set to true, then reference counting is turned off for objects of this class
qore_type_t | type: 11
| the type of the object More...
bool | value: 1
| this is true for values, if false then either the type needs evaluation to produce a value or is a parse expression
Protected Attributes inherited from QoreReferenceCounter
QoreThreadLock | mRO
| pthread lock to ensure atomicity of updates for architectures where we don't have an atomic increment and decrement implementation

## Detailed Description

this class implements Qore's 64-bit integer data type, reference-counted, dynamically-allocated only

## Constructor & Destructor Documentation

DLLEXPORT QoreBigIntNode::QoreBigIntNode | ( | int64 | v | ) |

creates a new integer with the value of "v"

Parameters

  v | the value of the integer

## Member Function Documentation

virtual DLLEXPORT int QoreBigIntNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

concatenates the value of the integer to an existing QoreString

used for n and N printf formatting. This implementation of the function never throws a Qore-language exception

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | is ignored

Returns
  always returns 0

Implements AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreBigIntNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

returns a QoreString representing the integer

used for n and N printf formatting

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, -1 = no line breaks
  xsink | is ignored NOTE: Use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead of using this function directly

See Also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

virtual DLLEXPORT DateTime* QoreBigIntNode::getDateTimeRepresentation | ( | bool & | del | ) | const
| virtual

returns the DateTime representation of this integer (interpreted as an offset in seconds from January 1, 1970)

NOTE: Use the DateTimeValueHelper class instead of using this function directly

Parameters

  del | output parameter: if del is true, then the returned DateTime pointer belongs to the caller (and must be deleted manually), if false, then it must not be

See Also
  DateTimeValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreBigIntNode::getDateTimeRepresentation | ( | DateTime & | dt | ) | const
| virtual

assigns the date representation of this integer (interpreted as an offset in seconds from January 1, 1970) to the DateTime reference passed

Parameters

  dt | the DateTime reference to be assigned

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT QoreString* QoreBigIntNode::getStringRepresentation | ( | bool & | del | ) | const
| virtual

returns a string representing the integer and sets del to true

NOTE: do not call this function directly, use QoreStringValueHelper instead

Parameters

  del | output parameter: always sets del to false

See Also
  QoreStringValueHelper

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT void QoreBigIntNode::getStringRepresentation | ( | QoreString & | str | ) | const
| virtual

concatentates the string representation of the integer to an existing QoreString reference

Parameters

  str | a reference to a QoreString where the value of the type will be concatenated

Reimplemented from AbstractQoreNode.

virtual DLLEXPORT bool QoreBigIntNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

tests for equality without the possibility of type conversion (hard compare)

this implementation of the function does not throw any Qore-language exceptions

Parameters

  v | the value to compare
  xsink | is ignored in this version of the function

Implements AbstractQoreNode.

virtual DLLEXPORT bool QoreBigIntNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const
| virtual

tests for equality with the possibility of type conversion (soft compare)

this implementation of the function does not throw any Qore-language exceptions

Parameters

  v | the value to compare
  xsink | is ignored in this version of the function

Implements AbstractQoreNode.

virtual DLLEXPORT AbstractQoreNode* QoreBigIntNode::realCopy | ( |  | ) | const
| virtual

returns a copy of the object; the caller owns the reference count

Returns
  a copy of the object; the caller owns the reference count

Implements AbstractQoreNode.

The documentation for this class was generated from the following file:

- include/qore/QoreBigIntNode.h (6585)